#include "Circles.h"
#include <StringView.h>
#include <stdlib.h>

// MAIN INSTANTIATION FUNCTION
extern "C" _EXPORT BScreenSaver *instantiate_screen_saver(BMessage *message, image_id image)
{
	return new Circles(message, image);
}

Circles::Circles(BMessage *message, image_id image)
 : BScreenSaver(message, image)
{
}

void Circles::StartConfig(BView *view)
{
	view->AddChild(new BStringView(BRect(10, 10, 200, 35), B_EMPTY_STRING, "Circles 1.0"));
	view->AddChild(new BStringView(BRect(10, 20, 200, 55), B_EMPTY_STRING, "by MacSnafu"));
	view->AddChild(new BStringView(BRect(10, 30, 200, 75), B_EMPTY_STRING, "Randomly-sized circles drawn at"));
	view->AddChild(new BStringView(BRect(10, 40, 200, 95), B_EMPTY_STRING, "random locations in random colors."));
	view->AddChild(new BStringView(BRect(10, 50, 200, 150), B_EMPTY_STRING, "e-mail: mclem@vigoris.net"));
	view->AddChild(new BStringView(BRect(10, 60, 200, 170), B_EMPTY_STRING, "website-"));
	view->AddChild(new BStringView(BRect(10, 70, 200, 190), B_EMPTY_STRING, "http://macsnafu.freeyellow.com"));
}

status_t Circles::StartSaver(BView *, bool /* preview */)
{
	SetTickSize(4000);
	return B_OK;
}

void Circles::Draw(BView *view, int32)
{
	// display circle
	int randomRadius;
	randomRadius = (rand() % view->Bounds().IntegerHeight());	
	
	BRect aRect;
	aRect.top = (rand() % view->Bounds().IntegerHeight() - (randomRadius / 2));
	aRect.left = (rand() % view->Bounds().IntegerWidth() - (randomRadius / 2));
	aRect.bottom = aRect.top + (randomRadius);
	aRect.right = aRect.left + (randomRadius);


	rgb_color randomColor;
	
	randomColor.red   = (rand() % 256);
	randomColor.blue  = (rand() % 256);
	randomColor.green = (rand() % 256);
	randomColor.alpha = 255;		
	
	view->SetHighColor(randomColor); 
	view->StrokeEllipse(aRect);
}
